{% extends 'id/id_base.html' %}

{% load static %}
{% load poll_extras %}

{% block content %}
<section>
    <div class="spacer">
        <div class="d-flex justify-content-between">
            <div class="d-flex align-items-center mb-3">
                {% if user.image %}
                <img class="avatar" src="{{ user.image.url }}" alt="profile" />
                {% else %}
                <img class="avatar" src="{% static 'images/common/placeholder.jpeg' %}" alt="placeholder" />
                {% endif %}
                <h3 class="h3 c-blue ps-3">{{ user.username }}</h3>
            </div>
            <div class="d-flex align-items-center mb-3">
                <i class="bi bi-pencil-square"></i>
                <a href="{% url 'frontend:contributor_profile_edit' %}" class="no-link">
                    <h3 class="h6 c-blue ps-3 pt-2">Ubah Profil</h3>
                </a>
            </div>
        </div>
        <div>
            <ul class="nav nav-tabs" id="myTab" role="tablist">
                <li class="nav-item" role="presentation">
                    <button class="nav-link active" id="profile-tab" data-bs-toggle="tab" data-bs-target="#profile"
                        type="button" role="tab" aria-controls="profile" aria-selected="false">Profil
                    </button>
                </li>
                <li class="nav-item" role="presentation">
                    <button class="nav-link" id="observation-tab" data-bs-toggle="tab" data-bs-target="#observation"
                        type="button" role="tab" aria-controls="observation" aria-selected="false">Observasi
                    </button>
                </li>
            </ul>
            <div class="tab-content" id="myTabContent">
                <div class="tab-pane fade show active" id="profile" role="tabpanel" aria-labelledby="profile-tab">
                    <div class="row py-3">
                        <div class="col-sm-12 col-lg-4">
                            {% if user.image %}
                            <img class="search-image" src="{{ user.image.url }}" />
                            {% else %}
                            <img class="search-image" src="https://picsum.photos/id/179/200/300" />
                            {% endif %}
                            <ul class="list-group mb-3">
                                <li class="list-group-item">
                                    <div class="row justify-content-between">
                                        <div class="col-6">
                                            <i class="bi bi-binoculars"></i> Observasi
                                        </div>
                                        <div class="col-3">
                                            <span class="badge rounded-pill bg-primary float-end">
                                                {{ observations|length }}
                                            </span>
                                        </div>
                                    </div>
                                </li>
                                <li class="list-group-item">
                                    <div class="row justify-content-between">
                                        <div class="col-6">
                                            <i class="bi bi-tree"></i> Spesies
                                        </div>
                                        <div class="col-3">
                                            <span class="badge rounded-pill bg-primary float-end">{{ species }}</span>
                                        </div>
                                    </div>
                                </li>
                                <li class="list-group-item">
                                    <div class="row justify-content-between">
                                        <div class="col-6">
                                            <i class="bi bi-person"></i> Pengikut
                                        </div>
                                        <div class="col-3">
                                            <span class="badge rounded-pill bg-primary float-end">
                                                {{ follower|length }}
                                            </span>
                                        </div>
                                    </div>
                                </li>
                            </ul>
                        </div>
                        <div class="col-sm-12 col-lg-8">
                            <div class="mb-5" id="profile">
                                <h3 class="h3 c-blue">{{ request.user.full_name|title }}</h3>
                                <div class="row justify-content-start mb-3">
                                    <div class="col-sm-12 col-lg-5">
                                        <i class="bi bi-calendar-event"></i>
                                        Bergabung: {{ request.user.joined_at|date:'M d, Y' }}
                                    </div>
                                    <div class="col-sm-12 col-lg-5">
                                        <i class="bi bi-geo-alt"></i> Indonesia
                                    </div>
                                </div>
                                <p class="fw-300 c-blue">
                                    {{ user.description|safe|default:"" }}
                                </p>
                            </div>
                            <div id="followers">
                                <h4 class="h4 c-blue">Mengikuti {{ following|length }} Orang</h4>
                                <hr />
                                <div class="row">
                                    {% for connection in following %}
                                    <div class="col-xs-12 col-lg-4">
                                        <a href="{% url 'frontend:contributor_profile_user' connection.following.username %}"
                                            class="d-flex align-items-center mb-3 no-link">
                                            {% if connection.following.image %}
                                            <img class="avatar" src="{{ connection.following.image.url }}" />
                                            {% else %}
                                            <img class="avatar" src="{% static 'images/common/placeholder.jpeg' %}"
                                                alt="placeholder" />
                                            {% endif %}
                                            <p class="ms-3 mt-3 c-blue">
                                                {{ connection.following.username }}
                                            </p>
                                        </a>
                                    </div>
                                    {% endfor %}
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="tab-pane fade" id="observation" role="tabpanel" aria-labelledby="observation-tab">
                    <div class="d-grid gap-2 d-md-flex justify-content-md-end mt-3">
                        <button type="button" class="btn btn-primary btn-block" data-bs-toggle="modal"
                            data-bs-target="#filterModal">
                            <i class="bi bi-filter"></i> Filter
                        </button>
                        <div class="modal fade" id="filterModal" tabindex="-1" aria-labelledby="filterModalLabel"
                            aria-hidden="true">
                            <div class="modal-dialog modal-lg">
                                <div class="modal-content">
                                    <div class="modal-header">
                                        <h5 class="modal-title" id="filterModalLabel">
                                            Filter
                                        </h5>
                                        <button type="button" class="btn-close" data-bs-dismiss="modal"
                                            aria-label="Close">
                                        </button>
                                    </div>
                                    <div class="modal-body">
                                        <form id="filter" class="row g-3">
                                            <div class="col-md-12 col-lg-4">
                                                <label for="date" class="form-label">Tanggal Ditambahkan</label>
                                                <select name="date" class="form-select">
                                                    <option value="ASC" {% if filter_date == 'ASC' %} selected {% endif %}>
                                                        Urutan Menaik
                                                    </option>
                                                    <option value="DESC" {% if filter_date == 'DESC' %} selected {% endif %}>
                                                        Urutan Menurun
                                                    </option>
                                                </select>
                                            </div>
                                            <div class="col-md-12 col-lg-4">
                                                <label for="" class="form-label">Kategori</label>
                                                <div class="form-check">
                                                    <input class="form-check-input" type="checkbox" name="category"
                                                        value="shark" {% if 'shark' in filter_categories %} checked {% endif %}>
                                                    <label class="form-check-label" for="category">
                                                        Hiu
                                                    </label>
                                                </div>
                                                <div class="form-check">
                                                    <input class="form-check-input" type="checkbox" name="category"
                                                        value="ray" {% if 'ray' in filter_categories %} checked {% endif %}>
                                                    <label class="form-check-label" for="category">
                                                        Pari
                                                    </label>
                                                </div>
                                                <div class="form-check">
                                                    <input class="form-check-input" type="checkbox" name="category"
                                                        value="chimaera" {% if 'chimaera' in filter_categories %} checked {% endif %}>
                                                    <label class="form-check-label" for="category">
                                                        Hiu Hantu
                                                    </label>
                                                </div>
                                            </div>
                                            <div class="col-md-12 col-lg-4">
                                                <label for="" class="form-label">Status</label>
                                                <div class="form-check">
                                                    <input class="form-check-input" type="checkbox" name="status"
                                                        value="VERIFIED" {% if 'VERIFIED' in filter_status %} checked {% endif %}>
                                                    <label class="form-check-label" for="status">
                                                        Verified
                                                    </label>
                                                </div>
                                                <div class="form-check">
                                                    <input class="form-check-input" type="checkbox" name="status"
                                                        value="PENDING" {% if 'PENDING' in filter_status %} checked {% endif %}>
                                                    <label class="form-check-label" for="status">
                                                        Pending
                                                    </label>
                                                </div>
                                                <div class="form-check">
                                                    <input class="form-check-input" type="checkbox" name="status"
                                                        value="REJECTED" {% if 'REJECTED' in filter_status %} checked {% endif %}>
                                                    <label class="form-check-label" for="status">
                                                        Rejected
                                                    </label>
                                                </div>
                                            </div>
                                            <div class="col-auto me-auto"></div>
                                            <div class="col-auto">
                                                <button type="submit" class="btn btn-success">
                                                    Apply
                                                </button>
                                            </div>
                                        </form>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <div class="row row-cols-1 row-cols-md-3 g-4 py-3">
                        {% for observation, observation_image in paginator_object %}
                        {% if observation.status == 'REJECTED' %}
                        <a href="{% url 'frontend:form_report_edit' observation.pk %}" class="no-link">
                            <div class="col">
                                <div class="card">
                                    {% if observation_image %}
                                    <img src="{{ observation_image.image.url }}" class="card-img-top">
                                    {% else %}
                                    <img src="{% static 'images/common/no-image.jpeg' %}" class="card-img-top">
                                    {% endif %}
                                    <div class="card-body c-blue">
                                        <span class="badge rounded-pill bg-danger mb-3">{{ observation.status }}</span>
                                        <h5 class="card-title">{{ observation.common_name|default:"Common Name" }}</h5>
                                        <p class="card-text">
                                            <i>({{ observation.scientific_name|default:"Scientific Name" }})</i>
                                        </p>
                                    </div>
                                </div>
                            </div>
                        </a>
                        {% else %}
                        <a href="{% url 'frontend:contributor_observation' observation.pk %}" class="no-link">
                            <div class="col">
                                <div class="card h-100">
                                    {% if observation_image %}
                                    <img src="{{ observation_image.image.url }}" class="card-img-top">
                                    {% else %}
                                    <img src="{% static 'images/common/no-image.jpeg' %}" class="card-img-top">
                                    {% endif %}
                                    <div class="card-body c-blue">
                                        {% if observation.status == 'PENDING' %}
                                        <span class="badge rounded-pill bg-warning mb-3">{{ observation.status }}</span>
                                        {% else %}
                                        <span class="badge rounded-pill bg-success mb-3">{{ observation.status }}</span>
                                        {% endif %}
                                        <h5 class="card-title">{{ observation.common_name|default:"Unidentified" }}</h5>
                                        <p class="card-text">
                                            <i>({{ observation.scientific_name|default:"Unidentified" }})</i>
                                        </p>
                                    </div>
                                </div>
                            </div>
                        </a>
                        {% endif %}
                        {% endfor %}
                    </div>
                    {% if paginator_object.has_other_pages %}
                    <nav aria-label="pagination">
                        <ul class="pagination justify-content-center mt-5">
                            {% if paginator_object.has_previous %}
                            <li class="page-item">
                                <a class="page-link"
                                    href="{{ request.get_full_path|unique_query_page }}&page={{ paginator_object.previous_page_number }}#observation">
                                    &laquo;
                                </a>
                            </li>
                            {% else %}
                            <li class="page-item disabled">
                                <span class="page-link">&laquo;</span>
                            </li>
                            {% endif %}
                            {% for p in page_range|default_if_none:paginator_object.paginator.get_elided_page_range %}
                            {% if paginator_object.number == p %}
                            <li class="page-item active">
                                <span class="page-link">{{ p }}</span>
                            </li>
                            {% else %}
                            <li class="page-item">
                                <a href="{{ request.get_full_path|unique_query_page }}&page={{ p }}#observation"
                                    class="page-link">
                                    {{ p }}
                                </a>
                            </li>
                            {% endif %}
                            {% endfor %}
                            {% if paginator_object.has_next %}
                            <li class="page-item">
                                <a href="{{ request.get_full_path|unique_query_page }}&page={{ paginator_object.next_page_number }}#observation"
                                    class="page-link">
                                    &raquo;
                                </a>
                            </li>
                            {% else %}
                            <li class="page-item disabled">
                                <span class="page-link">&raquo;</span>
                            </li>
                            {% endif %}
                        </ul>
                    </nav>
                    {% endif %}
                </div>
            </div>
        </div>
    </div>
</section>
{% endblock %}

{% block js %}
<script>
    $(document).ready(function () {
        var triggerTabList = [].slice.call(document.querySelectorAll('#myTab button'))
        triggerTabList.forEach(function (triggerEl) {
            var tabTrigger = new bootstrap.Tab(triggerEl)

            triggerEl.addEventListener('click', function (event) {
                event.preventDefault()
                tabTrigger.show()
            })
        })

        // Parse URL to get hash
        var hash = window.location.hash;

        // Show tab corresponding to the hash
        if (hash) {
            var triggerEl = document.querySelector('#myTab button[data-bs-target="' + hash + '"]')
            bootstrap.Tab.getInstance(triggerEl).show() // Select tab by name
        }

        var filterForm = $("#filter");
        filterForm.on("submit", function (event) {
            event.preventDefault();
            var queryParams = filterParameters(filterForm.serialize());
            if (queryParams == undefined) {
                toastr.error("Pilih min 1 kategori and status")
                return;
            }

            window.location = `/contributor/profile?${queryParams}#observation`
        });

        function filterParameters(parametersString) {
            // Split the parameters string into an array of key-value pairs
            const paramsArray = parametersString.split('&');

            // Initialize variables to store filtered parameters
            let filteredParams = [];
            let categoryParams = [];
            let categoryCount = 0;
            let statusParams = [];
            let statusCount = 0;

            // Iterate through the parameters array
            paramsArray.forEach(param => {
                const [key, value] = param.split('=');
                if (key === 'date' && value.toUpperCase() === 'DESC') {
                    filteredParams.push(param);
                } else if (key === 'category') {
                    categoryParams.push(param);
                    categoryCount++;
                } else if (key == 'status') {
                    statusParams.push(param);
                    statusCount++;
                }
            });

            if (categoryCount === 0 || statusCount === 0) {
                return undefined;
            }

            if (categoryCount <= 2) {
                filteredParams = filteredParams.concat(categoryParams)
            }

            if (statusCount <= 2) {
                filteredParams = filteredParams.concat(statusParams)
            }

            return filteredParams.join('&')
        }
    });
</script>
{% endblock %}